/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package es.uca.takuan.netbeans.wizard;

import java.util.List;
import java.util.Vector;
import javax.swing.DefaultComboBoxModel;
import javax.swing.DefaultListModel;
import javax.swing.JFrame;
import javax.swing.JPanel;
import org.openide.util.NbBundle;

public final class BpelVisualPanel6 extends JPanel {

    public List<String> removed;

    /** Creates new form BpelVisualPanel6 */
    public BpelVisualPanel6() {
        initComponents();
        removed = new Vector<String>();
    }

    @Override
    public String getName() {
        return NbBundle.getMessage(BpelVisualPanel6.class, "WIZARD_DEPENDENCIES_TITLE");
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        lblDescription = new javax.swing.JLabel();
        lblTestSuite = new javax.swing.JLabel();
        comboTestSuite = new javax.swing.JComboBox();
        lblDependencies = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        lstDependencies = new javax.swing.JList();
        cmdAdd = new javax.swing.JButton();
        cmdDel = new javax.swing.JButton();

        lblDescription.setFont(new java.awt.Font("Dialog", 0, 12));
        org.openide.awt.Mnemonics.setLocalizedText(lblDescription, org.openide.util.NbBundle.getMessage(BpelVisualPanel6.class, "WIZARD_DEPENDENCIES_DESCRIPTION")); // NOI18N
        lblDescription.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        lblDescription.setMinimumSize(new java.awt.Dimension(109, 28));
        lblDescription.setPreferredSize(new java.awt.Dimension(109, 63));
        lblDescription.setRequestFocusEnabled(false);

        lblTestSuite.setFont(new java.awt.Font("Dialog", 1, 11));
        org.openide.awt.Mnemonics.setLocalizedText(lblTestSuite, org.openide.util.NbBundle.getMessage(BpelVisualPanel6.class, "WIZARD_DEPENDENCIES_TESTSUITE")); // NOI18N

        comboTestSuite.setBackground(javax.swing.UIManager.getDefaults().getColor("TextArea.background"));
        comboTestSuite.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "test10.bpts", "test50.bpts" }));

        lblDependencies.setFont(new java.awt.Font("Dialog", 1, 11));
        org.openide.awt.Mnemonics.setLocalizedText(lblDependencies, org.openide.util.NbBundle.getMessage(BpelVisualPanel6.class, "WIZARD_DEPENDENCIES_DEPENDENCIES")); // NOI18N

        jScrollPane1.setViewportView(lstDependencies);

        cmdAdd.setIcon(new javax.swing.ImageIcon(getClass().getResource("/es/uca/takuan/netbeans/add.png"))); // NOI18N
        cmdAdd.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdAddActionPerformed(evt);
            }
        });

        cmdDel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/es/uca/takuan/netbeans/remove.png"))); // NOI18N
        cmdDel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdDelActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(lblDependencies)
                    .add(comboTestSuite, 0, 452, Short.MAX_VALUE)
                    .add(lblTestSuite)
                    .add(layout.createSequentialGroup()
                        .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 394, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(cmdAdd, 0, 0, Short.MAX_VALUE)
                            .add(cmdDel, 0, 0, Short.MAX_VALUE)))
                    .add(lblDescription, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 452, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(lblDescription, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(lblDependencies)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(lblTestSuite))
                    .add(layout.createSequentialGroup()
                        .add(54, 54, 54)
                        .add(cmdAdd)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(cmdDel)))
                .add(4, 4, 4)
                .add(comboTestSuite, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(32, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void cmdAddActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdAddActionPerformed
        JFrame frame = new JFrame();
        ListSelector selector = new ListSelector(frame, true);

        // Show only removed items
        DefaultListModel model = (DefaultListModel) selector.lstFiles.getModel();
        model.clear();

        int i;
        for(i = 0; i < removed.size(); i++) {
            model.addElement(removed.get(i));
        }

        // Show
        selector.setVisible(true);

        // Recover
        if(selector.accepted()) {
            DefaultListModel dependenciesModel  = (DefaultListModel) lstDependencies.getModel();
            DefaultComboBoxModel testSuiteModel = (DefaultComboBoxModel) comboTestSuite.getModel();
            for(i = 0; i < model.getSize(); i++) {
                if(selector.lstFiles.isSelectedIndex(i)) {
                    String file = (String) model.get(i);

                    if(file.endsWith(".bpts")) // BPTS
                        testSuiteModel.addElement(file);
                    else // Regular file
                        dependenciesModel.addElement(file);
                }
            }
        }
}//GEN-LAST:event_cmdAddActionPerformed

    private void cmdDelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdDelActionPerformed
        int [] selection = lstDependencies.getSelectedIndices();
        int i;
        DefaultListModel model = (DefaultListModel) lstDependencies.getModel();

        // We remove from end to beggining
        for(i = selection.length - 1; i >= 0; i--) {
            removed.add((String) model.get(selection[i])); // Remember
            model.removeElementAt(selection[i]);
        }
}//GEN-LAST:event_cmdDelActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cmdAdd;
    private javax.swing.JButton cmdDel;
    public javax.swing.JComboBox comboTestSuite;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel lblDependencies;
    private javax.swing.JLabel lblDescription;
    private javax.swing.JLabel lblTestSuite;
    public javax.swing.JList lstDependencies;
    // End of variables declaration//GEN-END:variables
}

